/*
* Use a circle and a dot structures to calculate whether a given dot is 
* contained in a given circle
*/

#include <stdio.h>
#include <math.h>


typedef struct point
{
    double x;
    double y;
} point_t;


typedef struct circle
{
    point_t center;
    double  radius;
} circle_t;



double distance(point_t * p1, point_t * p2){
	return sqrt((p1->x - p2->x) * (p1->x - p2->x) + (p1->y - p2->y) * (p1->y - p2->y));
}

/*
* Deterrmines if a point p lies within the circle c)
*/

int is_in_circle(point_t *p, circle_t *c)
{
    return (distance(p, &c->center) <= c->radius);
}


int main(void)
{
    point_t  p;
    circle_t c;

    printf("Enter point coordinates\n");
    scanf("%lf%lf", &p.x, &p.y);
    printf("Enter circle center coordinates\n");
    scanf("%lf%lf", &c.center.x, &c.center.y);
    printf("Enter circle radius\n");
    scanf("%lf", &c.radius);

    if (is_in_circle(&p, &c))
        printf("point is in circle\n");
    else
        printf("point is out of circle\n");

    return 0;
}
