#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#define NUM_STUDENTS 6
#define TRUE 1
#define FALSE 0

// Section A
typedef struct student {
	char name[40];
	int best_friend;
} Student;

// Section B
int inCircle(Student course[], int size, int studentIndex)
{
	int i, curr = course[studentIndex].best_friend;

	for (i = 0; i < size && curr != studentIndex; i++)
	{
		curr = course[curr].best_friend;
	}
	return i != size ? TRUE : FALSE;
}

// Section C
void printCircle(Student course[], int wasPrinted[], 
                 int size, int studentIndex) 
{
	int i;

	if (!inCircle(course, size, studentIndex))
		return;

	printf("[");
	i = studentIndex; 
	do
	{
		printf("%s", course[i].name);
		wasPrinted[i] = 1;
		i = course[i].best_friend;
		if (i != studentIndex)
			printf(", ");
	} while (i != studentIndex);
	printf("]\n");
}

// Section D
void printAllCircles(Student course[], int printed[] , int size) 
{
	int i;
	
	for (i = 0; i < size; i++)
		if (!printed[i]) 
			printCircle(course, printed, size, i);
	
}

// Test program
int main()
{
	Student students[NUM_STUDENTS] = { {"Avraham", 1},
							{"Yitzchaq", 3},
							{"Jacob", 0},
							{"Sara", 0},
							{"Rivka", 5},
							{"Rachel", 4} };
	
	int printed[NUM_STUDENTS] = {0};

	printAllCircles(students, printed  , NUM_STUDENTS);

	return 0;
}

